
' (C) 2007 i-TECH and Kristopher Windsor

' Multiput by Joshy (D. J. Peters)
' Alpha Blending by Counting_Pine
' Exported to a single BI file by Kristopher Windsor

'macro by 1000101
#Macro itech_image_ipset (target, x, y, c)
  target[(y) * screen_size_x + x] = c
#EndMacro

#Macro itech_image_ipoint (source, x, y, c)
  c = source[(y) * screen_size_x + x]
#EndMacro

Sub scaler Overload (Byval target As fb.image Ptr, Byval x As Integer = 0, Byval y As Integer = 0, Byval source As fb.image Ptr, Byval scale As float)
  Dim As Integer dest_size_x, dest_size_y
  Dim As Integer dest_loop_x, dest_loop_y
  Dim As Integer srce_size_x, srce_size_y
  Dim As Integer srce_loop_x, srce_loop_y
  Dim As Integer srce_color
  Dim As float red, green, blue
  Dim As float x1, y1, x2, y2, overlap_factor, total_pixels
  Dim As float overlap_1, overlap_2, overlap_3, overlap_4, overlap_5, overlap_6 'temp variables to see how much of a certain source pixel overlaps a destination pixel
  
  srce_size_x = source -> Width
  srce_size_y = source -> height
  dest_size_x = srce_size_x * scale
  dest_size_y = srce_size_y * scale
  
  'loop for each destination pixel
  For dest_loop_x = 0 To dest_size_x - 1
    For dest_loop_y = 0 To dest_size_y - 1
      'find the source pixels under this destination pixel
      x1 = cfloat(dest_loop_x) / dest_size_x * srce_size_x - .5
      x2 = cfloat(dest_loop_x + 1) / dest_size_x * srce_size_x - .5
      y1 = cfloat(dest_loop_y) / dest_size_y * srce_size_y - .5
      y2 = cfloat(dest_loop_y + 1) / dest_size_y * srce_size_y - .5
      
      'loop through all of the source pixels under this destination pixel to get the average color
      red = 0: green = 0: blue = 0: total_pixels = 0
      For srce_loop_x = x1 To x2
        For srce_loop_y = y1 To y2
          'the following can be replaced with 'overlap_factor = 1,' but it will be slightly less accurate (especially in the last row and column)
          'overlaps 1, 2: location of destination pixel; 3, 4: part of source pixel under destination pixel; 5, 6: location of source pixel
          'x overlap factor
          overlap_1 = cfloat(dest_loop_x) / dest_size_x
          overlap_2 = cfloat(dest_loop_x + 1) / dest_size_x
          overlap_3 = cfloat(srce_loop_x) / srce_size_x
          overlap_4 = cfloat(srce_loop_x + 1) / srce_size_x
          overlap_5 = overlap_3
          overlap_6 = overlap_4
          If overlap_3 < overlap_1 Or overlap_3 > overlap_2 Then overlap_3 = Iif(Abs(overlap_3 - overlap_1) < Abs(overlap_3 - overlap_2), overlap_1, overlap_2)
          If overlap_4 < overlap_1 Or overlap_4 > overlap_2 Then overlap_4 = Iif(Abs(overlap_4 - overlap_1) < Abs(overlap_4 - overlap_2), overlap_1, overlap_2)
          overlap_factor = Abs((overlap_3 - overlap_4) / (overlap_5 - overlap_6))
          'y overlap factor
          overlap_1 = cfloat(dest_loop_y) / dest_size_y
          overlap_2 = cfloat(dest_loop_y + 1) / dest_size_y
          overlap_3 = cfloat(srce_loop_y) / srce_size_y
          overlap_4 = cfloat(srce_loop_y + 1) / srce_size_y
          overlap_5 = overlap_3
          overlap_6 = overlap_4
          If overlap_3 < overlap_1 Or overlap_3 > overlap_2 Then overlap_3 = Iif(Abs(overlap_3 - overlap_1) < Abs(overlap_3 - overlap_2), overlap_1, overlap_2)
          If overlap_4 < overlap_1 Or overlap_4 > overlap_2 Then overlap_4 = Iif(Abs(overlap_4 - overlap_1) < Abs(overlap_4 - overlap_2), overlap_1, overlap_2)
          overlap_factor *= Abs((overlap_3 - overlap_4) / (overlap_5 - overlap_6))
          
          'overlap_factor = 1
          If overlap_factor > 1E-12 Then
            srce_color = Point(srce_loop_x, srce_loop_y, source)
            if srce_color <> &HFFFF00FF then
              total_pixels += overlap_factor 'if all of the source pixel is under the destination pixel, then a whole pixel is added
              'itech_image_ipoint (scrptr, srce_loop_x, srce_loop_y, srce_color)
              red += ((srce_color And &H00FF0000) Shr 16) * overlap_factor
              green += ((srce_color And &H0000FF00) Shr 8) * overlap_factor
              blue += (srce_color And &H000000FF) * overlap_factor
            end if
          End If
        Next y
      Next x
      
      'draw
      if total_pixels > 1 then
        red /= total_pixels: green /= total_pixels: blue /= total_pixels
        Pset target, (x + dest_loop_x, y + dest_loop_y), (256 Shl 24) Or (red Shl 16) Or (green Shl 8) Or blue
      else
        Pset target, (x + dest_loop_x, y + dest_loop_y), &HFFFF00FF
      end if
      'itech_image_ipset (scrptr, x + dest_loop_x, y + dest_loop_y, (256 Shl 24) Or (red Shl 16) Or (green Shl 8) Or blue)
    Next dest_loop_y
  Next dest_loop_x
End Sub

Sub scaler Overload (Byval x As Integer = 0, Byval y As Integer = 0, Byval source As fb.image Ptr, Byval scale As float)
  scaler 0, x, y, source, scale
End Sub

' MultiPut [destination],[xmidpos],[ymidpos],source,[xScale],[yScale],[Trans]
Sub MultiPut(Byval lpTarget As Any Ptr = 0, _
             Byval xMidPos  As Integer, _
             Byval yMidPos  As Integer, _
             Byval lpSource As Any Ptr, _
             Byval xScale   As Single = 1, _
             Byval yScale   As Single = 1, _
             Byval Rotate   As Single = 0, _
             Byval Trans    As Integer= 0, _
             Byval alphavalue As Integer = 255)

  If alphavalue <= 0 Or alphavalue >= 256 Then Exit Sub
  If xScale < 0.001 Then xScale=0.001
  If yScale < 0.001 Then yScale=0.001

  Dim As Integer MustRotate, MustLock

  'variables for the alpha blending
  Dim As Uinteger srb = Any
  Dim As Uinteger drb = Any
  Dim As Uinteger  rb = Any
  Dim As Uinteger sr = Any, sg = Any, sb = Any, sa = Any, sa2 = Any
  Dim As Uinteger dr = Any, dg = Any, db = Any, da = Any, da2 = Any
  Dim As Uinteger  r = Any,  g = Any,  b = Any,  a = Any

  If lpTarget= 0 Then MustLock = 1
  If Rotate <> 0 Then MustRotate = 1

  Dim As Integer  TargetWidth,TargetHeight,TargetPitch

  If MustLock Then
    Screeninfo    _
    TargetWidth , _
    TargetHeight,,, _
    TargetPitch
    lpTarget=Screenptr
  Else
    TargetWidth  = Cptr(Uinteger Ptr,lpTarget)[2]
    TargetHeight = Cptr(Uinteger Ptr,lpTarget)[3]
    TargetPitch  = Cptr(Uinteger Ptr,lpTarget)[4]
    lpTarget    += 32
  End If

  Dim As Integer   SourceWidth,SourceHeight,SourcePitch
  If Cptr(Integer Ptr,lpSource)[0] = 7 Then
    SourceWidth  = Cptr(Uinteger Ptr,lpSource)[2]
    SourceHeight = Cptr(Uinteger Ptr,lpSource)[3]
    SourcePitch  = Cptr(Uinteger Ptr,lpSource)[4]
    lpSource    += 32
  Else
    SourceWidth  = Cptr(Ushort Ptr,lpSource)[0] Shr 3
    SourceHeight = Cptr(Ushort Ptr,lpSource)[1]
    SourcePitch  = SourceWidth
    lpSource    += 2
  End If
#define xs 0 'screen
#define ys 1
#define xt 2 'texture
#define yt 3
  Dim As Single Points(3,3)
  points(0,xs)=-SourceWidth/2 * xScale
  points(1,xs)= SourceWidth/2 * xScale
  points(2,xs)= points(1,xs)
  points(3,xs)= points(0,xs)

  points(0,ys)=-SourceHeight/2 * yScale
  points(1,ys)= points(0,ys)
  points(2,ys)= SourceHeight/2 * yScale
  points(3,ys)= points(2,ys)

  points(1,xt)= SourceWidth-1
  points(2,xt)= points(1,xt)
  points(2,yt)= SourceHeight-1
  points(3,yt)= points(2,yt)

  Dim As Uinteger i
  Dim As Single x,y
  If MustRotate Then
    While Rotate< 0:rotate+=6.2831853:Wend
    While Rotate>=6.2831853:rotate-=6.2831853:Wend
    For i=0 To 3
      x=points(i,xs)*Cos(Rotate) - points(i,ys)*Sin(Rotate)
      y=points(i,xs)*Sin(Rotate) + points(i,ys)*Cos(Rotate)
      points(i,xs)=x:points(i,ys)=y
    Next
  End If

  Dim As Integer yStart,yEnd,xStart,xEnd
  yStart=100000:yEnd=-yStart:xStart=yStart:xEnd=yEnd

#define LI 0   'LeftIndex
#define RI 1   'RightIndex
#define  IND 0 'Index
#define NIND 1 'NextIndex
  Dim As Integer CNS(1,1) 'Counters

  For i=0 To 3
    points(i,xs)=Int(points(i,xs)+xMidPos)
    points(i,ys)=Int(points(i,ys)+yMidPos)
    If points(i,ys)<yStart Then yStart=points(i,ys):CNS(LI,IND)=i
    If points(i,ys)>yEnd   Then yEnd  =points(i,ys)
    If points(i,xs)<xStart Then xStart=points(i,xs)
    If points(i,xs)>xEnd   Then xEnd  =points(i,xs)
  Next
  If yStart =yEnd         Then Exit Sub
  If yStart>=TargetHeight Then Exit Sub
  If yEnd   <0            Then Exit Sub
  If xStart = xEnd        Then Exit Sub
  If xStart>=TargetWidth  Then Exit Sub
  If xEnd   <0            Then Exit Sub

  Dim As Ubyte    Ptr t1,s1
  Dim As Ushort   Ptr t2,s2
  Dim As Uinteger Ptr t4,s4


#define ADD 0
#define CMP 1
#define SET 2
  Dim As Integer ACS(1,2) 'add compare and set
  ACS(LI,ADD)=-1:ACS(LI,CMP)=-1:ACS(LI,SET)=3
  ACS(RI,ADD)= 1:ACS(RI,CMP)= 4:ACS(RI,SET)=0

#define EX  0
#define EU  1
#define EV  2
#define EXS 3
#define EUS 4
#define EVS 5
  Dim As Single E(2,6),S(6),Length,uSlope,vSlope
  Dim As Integer U,UV,UA,UN,V,VV,VA,VN

  ' share the same highest point
  CNS(RI,IND)=CNS(LI,IND)

  ' loop from Top to Bottom
  While yStart<yEnd
    'Scan Left and Right sides together
    For i=LI To RI
      ' bad to read but fast and short ;-)
      If yStart=points(CNS(i,IND),ys) Then
        CNS(i,NIND)=CNS(i,IND)+ACS(i,Add)
        If CNS(i,NIND)=ACS(i,CMP) Then CNS(i,NIND)=ACS(i,SET)
        While points(CNS(i,IND),ys) = points(CNS(i,NIND),ys)
          CNS(i, IND)=CNS(i,NIND)
          CNS(i,NIND)=CNS(i, IND)+ACS(i,Add)
          If CNS(i,NIND)=ACS(i,CMP) Then CNS(i,NIND)=ACS(i,SET)
        Wend
        E(i,EX) = points(CNS(i, IND),xs)
        E(i,EU) = points(CNS(i, IND),xt)
        E(i,EV) = points(CNS(i, IND),yt)
        Length  = points(CNS(i,NIND),ys)
        Length -= points(CNS(i, IND),ys)
        If Length <> 0.0 Then
          E(i,EXS) = points(CNS(i, NIND),xs)-E(i,EX):E(i,EXS)/=Length
          E(i,EUS) = points(CNS(i, NIND),xt)-E(i,EU):E(i,EUS)/=Length
          E(i,EVS) = points(CNS(i, NIND),yt)-E(i,EV):E(i,EVS)/=Length
        End If
        CNS(i,IND)=CNS(i,NIND)
      End If
    Next

    If (yStart<0)                              Then Goto SkipScanLine
    xStart=E(LI,EX)+0.5:If xStart>=TargetWidth Then Goto SkipScanLine
    xEnd  =E(RI,EX)-0.5:If xEnd  < 0           Then Goto SkipScanLine
    If (xStart=xEnd)                           Then Goto SkipScanLine

    Length=xEnd-xStart
    uSlope=E(RI,EU)-E(LI,EU):uSlope/=Length
    vSlope=E(RI,EV)-E(LI,EV):vSlope/=Length
    If xstart<0 Then
      Length=Abs(xStart)
      U=Int(E(LI,EU)+uSlope*Length)
      V=Int(E(LI,EV)+vSlope*Length)
      xStart = 0
    Else
      U=Int(E(LI,EU)):V=Int(E(LI,EV))
    End If
    If xEnd>=TargetWidth Then xEnd=TargetWidth-1
    UV=Int(uSlope):UA=(uSlope-UV)*10000:UN=0
    VV=Int(vSlope):VA=(vSlope-VV)*10000:VN=0
    xEnd-=xStart

    t4=Cptr(Integer Ptr,lpTarget)+yStart*(TargetPitch Shr 2)+xStart:xStart=0
    If Trans=0 Then
      While xStart<xEnd
        s4=Cptr(Integer Ptr,lpSource)+V*(SourcePitch Shr 2)+U
        '***** start alpha blending
        'this set of if...elseif...end if conditions applies alpha blending
        'these 43 lines can be replaced with '*t4 = *s4' to remove blending
        If alphavalue = 0 Then
          'no change needed *t4 = *t4
        Elseif alphavalue = 255 Then
          *t4 = *s4
        Elseif *t4 Shr 24 = 0 Then
          *t4 = *s4
        Elseif *t4 Shr 24 = 255 Then
          srb = *s4 And &h00ff00ff
          sg  = *s4 Xor srb
          sa  = alphavalue

          drb = *t4 And &h00ff00ff
          dg  = *t4 Xor drb
          da  = 256 - sa

          rb = (drb * da + srb * sa) And &hff00ff00
          g  = (dg  * da + sg  * sa) And &h00ff0000

          *t4 = (rb Or g) Shr 8 Or &hff000000
        Else
          sr = (*s4 Shr 16) And 255
          sg = (*s4 Shr  8) And 255
          sb = (*s4       ) And 255
          sa = (alphavalue)
         
          dr = (*t4 Shr 16) And 255
          dg = (*t4 Shr  8) And 255
          db = (*t4       ) And 255
          da = (*t4 Shr 24)

          sa2 = sa Shl 8
          da2 = da Shl 8 - da * sa
          a = (sa2 + da2)

          r = (dr * da2 + sr * sa2) \ a
          g = (dg * da2 + sg * sa2) \ a
          b = (db * da2 + sb * sa2) \ a
          *t4 = Rgba(r, g, b, a Shr 8)
        End If
        '***** end alpha blending
        U+=UV:UN+=UA:If UN>=10000 Then U+=1:UN-=10000
        V+=VV:VN+=VA:If VN>=10000 Then V+=1:VN-=10000
        If u<0 Then u=0
        If v<0 Then v=0
        xStart+=1:t4+=1
      Wend
    Else
      While xStart<xEnd
        s4=Cptr(Integer Ptr,lpSource)+V*(SourcePitch Shr 2)+U
        If (*s4 And &HFFFFFF) <> &HFF00FF Then
          '***** start alpha blending
          'this set of if...elseif...end if conditions applies alpha blending
          'these 43 lines can be replaced with '*t4 = *s4' to remove blending
          If alphavalue = 0 Then
            'no change needed *t4 = *t4
          Elseif alphavalue = 255 Then
            *t4 = *s4
          Elseif *t4 Shr 24 = 0 Then
            *t4 = *s4
          Elseif *t4 Shr 24 = 255 Then
            srb = *s4 And &h00ff00ff
            sg  = *s4 Xor srb
            sa  = alphavalue

            drb = *t4 And &h00ff00ff
            dg  = *t4 Xor drb
            da  = 256 - sa

            rb = (drb * da + srb * sa) And &hff00ff00
            g  = (dg  * da + sg  * sa) And &h00ff0000

            *t4 = (rb Or g) Shr 8 Or &hff000000
          Else
            sr = (*s4 Shr 16) And 255
            sg = (*s4 Shr  8) And 255
            sb = (*s4       ) And 255
            sa = (alphavalue)
           
            dr = (*t4 Shr 16) And 255
            dg = (*t4 Shr  8) And 255
            db = (*t4       ) And 255
            da = (*t4 Shr 24)

            sa2 = sa Shl 8
            da2 = da Shl 8 - da * sa
            a = (sa2 + da2)

            r = (dr * da2 + sr * sa2) \ a
            g = (dg * da2 + sg * sa2) \ a
            b = (db * da2 + sb * sa2) \ a
            *t4 = Rgba(r, g, b, a Shr 8)
          End If
          '***** end alpha blending
        End If
        U+=UV:UN+=UA:If UN>=10000 Then U+=1:UN-=10000
        V+=VV:VN+=VA:If VN>=10000 Then V+=1:VN-=10000
        If u<0 Then u=0
        If v<0 Then v=0
        xStart+=1:t4+=1
      Wend
    End If

    SkipScanLine:
    E(LI,EX)+=E(LI,EXS):E(LI,EU)+=E(LI,EUS):E(LI,EV)+=E(LI,EVS)
    E(RI,EX)+=E(RI,EXS):E(RI,EU)+=E(RI,EUS):E(RI,EV)+=E(RI,EVS)
    yStart+=1:If yStart=TargetHeight Then yStart=yEnd 'exit loop
  Wend
End Sub
